<?php
if (session_status() === PHP_SESSION_NONE) {
    session_start();
}
include 'config.php';
$version = getVersion();
function getVersion()
{
    $version  = "0.0";
    $txt_file = file_get_contents('./Version.properties');
    $rows     = explode("\n", $txt_file);
    array_shift($rows);
    foreach ($rows as $row) {
        $found = preg_match('/^version=(.*)/', $row, $matches);
        if ($found === 1) {
            return $matches[1];
        }
    }
}
function isSSL()
{
  if (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] === 'https') {
    return true;
  }
  if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on') {
    return true;
  }
  return false;
}
$connectViaSSL = isSSL();
$contextURL = $_SERVER['REQUEST_URI'];
$contextURL = str_replace("//", "/", $contextURL);
$pos        = strpos($contextURL, "/", 1);
if ($pos > 0) {
    $contextURL = substr($contextURL, 0, $pos) . "/";
}
$baseURL = ($connectViaSSL  ? "https" : "http") . "://{$_SERVER['HTTP_HOST']}" . $contextURL;
include 'config.php';
if (!isset($_SESSION["init"])) {
    $_SESSION["init"] = 0;
}
if ($installed == 0 || $_SESSION["init"] == 2) {
    if ($_SESSION["init"] > 0) {
        $restURL = $_SESSION["restURL"];
    } else {
        header("Location: " . $baseURL . "install.php");
        exit;
    }
}
?> <!doctype html> <html lang="en"> <head> <meta charset="utf-8"/> <meta name="viewport" content="width=device-width,initial-scale=1"/> <meta name="mobile-web-app-capable" content="yes"/> <meta name="apple-mobile-web-app-capable" content="yes"/> <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent"/> <link rel="stylesheet" href="<?php echo $baseURL ?>fonts/roboto.css"/> <link rel="stylesheet" href="<?php echo $baseURL ?>fonts/material-icons.css"/> <link rel="stylesheet" href="<?php echo $baseURL ?>customStyles.css"/> <link rel="icon" href="<?php echo $baseURL ?>images/favicon.ico?v=2"/> <title> <?php if (isset($title)) { echo $title; } else { echo "Allegra Service
      Desk";} ?> </title> <script>window.resourceBasePath="<?php echo $contextURL ?>",window.restPath="<?php echo $restURL ?>/rest/",window.currentVersion="<?php echo $version ?>"</script> <script>window.WELCOME_TITLE="<?php if (isset($welcomeTitle)) { echo $welcomeTitle;} else { echo "";}?>",window.ALWAYS_SHOW_TOP_LEVEL_WORKSPACE="<?php if (isset($alwaysShowTopLevelWorkspace)) { echo $alwaysShowTopLevelWorkspace;} else { echo "false";}?>",window.SHOW_PHONE_NUMBER="<?php if (isset($showPhoneNumber)) { echo $showPhoneNumber;} else { echo "false";}?>",window.SHOW_COMPANY_NAME="<?php if (isset($showCompanyName)) { echo $showCompanyName;} else { echo "false";}?>",window.SHOW_WATCHERS="<?php if (isset($showWatchers)) { echo $showWatchers;} else { echo "false";}?>",window.SHOW_CHECKBOX_LOGIN="<?php if (isset($showCheckboxLogin)) { echo $showCheckboxLogin;} else { echo "false";}?>",window.CHECKBOX_LOGIN_LABEL_LINK="<?php if (isset($checkboxLoginLabelLink)) { echo $checkboxLoginLabelLink;} else { echo "";}?>",window.SHOW_CHECKBOX_REGISTRATION="<?php if (isset($showCheckboxRegistration)) { echo $showCheckboxRegistration;} else { echo "false";}?>",window.CHECKBOX_REGISTRATION_LABEL_LINK="<?php if (isset($checkboxRegistrationLabelLink)) { echo $checkboxRegistrationLabelLink;} else { echo "";}?>",window.REMOVE_FORGOT_PWD="<?php if (isset($removeForgotPwd)) { echo $removeForgotPwd;} else { echo "false";}?>"</script> <script>window.PRINT_CONFIG= <?php if (isset($printConfig)) { echo json_encode($printConfig);} else { echo "false";}?>,window.CHECKBOX_LOGIN_LABEL_OPTIONS= <?php if (isset($checkboxLoginLabelOptions)) { echo json_encode($checkboxLoginLabelOptions);} else { echo "false";}?>,window.CHECKBOX_LOGIN_TOOLTIP_OPTIONS= <?php if (isset($checkboxLoginTooltipOptions)) { echo json_encode($checkboxLoginTooltipOptions);} else { echo "false";}?>,window.CHECKBOX_REGISTRATION_LABEL_OPTIONS= <?php if (isset($checkboxRegistrationLabelOptions)) { echo json_encode($checkboxRegistrationLabelOptions);} else { echo "false";}?>,window.CHECKBOX_REGISTRATION_TOOLTIP_OPTIONS= <?php if (isset($checkboxRegistrationTooltipOptions)) { echo json_encode($checkboxRegistrationTooltipOptions);} else { echo "false";}?>,window.FONT_DEFINITION= <?php if (isset($fontDefinition)) { echo json_encode($fontDefinition);} else { echo "false";}?></script> <style>html{height:100%}body{background-color:#fff;min-height:100%;height:1px;display:flex;flex-direction:column;flex-wrap:nowrap}#app{display:flex;height:100%;overflow:auto}</style> <script defer="defer" src="app/runtime~main.dac609ebc6467b0a5ab7.js"></script><script defer="defer" src="app/main.d3b07c7d15f88041ef6f.js"></script><meta name="apple-mobile-web-app-title" content="Allegra Service Desk" /><meta name="apple-mobile-web-app-capable" content="yes" /><meta name="apple-mobile-web-app-status-bar-style" content="default" /><meta name="theme-color" content="#fafafa" /><link rel="manifest" href="./manifest.fbc0138bfcedec91f45dfd05831bc401.json" /></head> <body id="appBody"> <noscript>If you're seeing this message, that means <strong>JavaScript has been disabled on your browser</strong>, please <strong>enable JS</strong> to make this app work.</noscript> <?php if(file_exists('header.php'))
    include 'header.php'; ?> <div id="app"></div> <?php if(file_exists('footer.php'))
    include 'footer.php'; ?> </body> </html> 