<?php
/* This file shall be executed from the command line and
   serves to update this Allegra Service Desk Module Installation.
   Configuration is all in config.php. This file will not be overwritten.
*/
include 'config.php';
$dlurl = "https://www.trackplus.com/files/downloads/sd/latest-dist/service-desk/allegra-sd-latest.zip";
$dir = ".";
$currentPwd = "";
$currentPwdErr = "";
$updating = false;
$updateSucces = false;
if ($_SERVER["REQUEST_METHOD"] == "POST") {
  $valid = true;
  // Check if password is valid, only after inital config 
  if (!isset($_POST['confirmPwd']) && $installed > 0) {
    if (md5($_POST['currentPwd']) != $pwd || empty($_POST["currentPwd"])) {
      $currentPwdErr = "Password not valid";
      $valid  = false;
    } else {
      $pwd = test_input($_POST["currentPwd"]);
    }
  }
  if ($valid  == true) {
    $updating = true;
    downloadFile($dlurl, "./service-desk-modul.zip");
    createTempFolder($dir);
    createTempCopy($dir);
    emptyDir($dir);
    unzip("./service-desk-modul.zip", $dir);
    unlink("./service-desk-modul.zip");
    restoreCopy($dir);
    deleteTempFolder($dir);
    $updateSucces = true;
  }
}
function test_input($data)
{
  $data = trim($data);
  $data = stripslashes($data);
  $data = htmlspecialchars($data);
  return $data;
}

function downloadFile($url, $path)
{
  $newfname = $path;
  $ch = curl_init($url);
  try {
    $newf = fopen($newfname, 'wb');
    if (!$newf) {
      throw new Exception('New File open failed.');
    }
    curl_setopt($ch, CURLOPT_FAILONERROR, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 600);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_FILE, $newf);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_exec($ch);
    if (curl_errno($ch)) {
      $error_msg = curl_error($ch);
      echo $error_msg . "\n";
    }
    curl_close($ch);
    fclose($newf);
  } catch (Exception $e) {
    echo "--------------UDPDATE NOT SUCCESSFUL--------------" . "\n";
    echo $e . "\n";
    exit();
  }
}
function unzip($zipFile, $destination)
{
  $zip = new ZipArchive;
  if ($zip->open($zipFile) === TRUE) {
    $zip->extractTo($destination);
    $zip->close();
  } else {
    echo "Can't extract ZIP file" . "\n";
  }
}
function createTempFolder($dir)
{
  // Create tempory folder for storing configurations, images and documents
  $di = new RecursiveDirectoryIterator($dir, FilesystemIterator::SKIP_DOTS);
  if (!file_exists($dir . '/temp')) {
    mkdir($dir . '/temp', 0777, true);
    mkdir($dir . '/temp/images', 0777, true);
    mkdir($dir . '/temp/documents', 0777, true);
  } else {
  }
}
function deleteTempFolder($dir)
{
  $di = new RecursiveDirectoryIterator($dir, FilesystemIterator::SKIP_DOTS);
  $ri = new RecursiveIteratorIterator($di, RecursiveIteratorIterator::CHILD_FIRST);
  foreach ($ri as $file) {
    if (strpos($file->getRealPath(), 'temp') == true) {
      if ($file->isDir()) {
        rmdir($file->getRealPath());
      } else {
        unlink($file->getRealPath());
      }
    }
  }
}

function createTempCopy($dir)
{
  // Copy Images
  copyFiles($dir . "/images", $dir . "/temp/images/");
  // Copy Documents
  if (is_dir($dir . "/documents")) {
    copyFiles($dir . "/documents", $dir . "/temp/documents/");
  }
  // Config Files
  copyConfigFiles($dir, $dir . "/temp/");
}
function restoreCopy($dir)
{
  // Copy Images
  copyFiles($dir . "/temp/images/", $dir . "/images/");
  // Copy Documents
  if (is_dir($dir . "/documents/")) {
    copyFiles($dir . "/temp/documents/", $dir . "/documents/");
  } else {
    mkdir($dir . '/documents', 0755, true);
    copyFiles($dir . "/temp/documents/", $dir . "/documents/");
  }
  // Copy config files
  copyConfigFiles($dir . "/temp/", $dir . "/");
}

function copyFiles($src, $dest)
{
  $di = new RecursiveDirectoryIterator($src, FilesystemIterator::SKIP_DOTS);
  $ri = new RecursiveIteratorIterator($di, RecursiveIteratorIterator::CHILD_FIRST);
  foreach ($ri as $file) {
    // echo 'Copying ' . $file->getRealPath() . " to " . $dest . $file->getFilename() . "\n";
    copy($file->getRealPath(), $dest . $file->getFilename());
  }
}

function copyConfigFiles($src, $dest)
{
  $di = new RecursiveDirectoryIterator($src, FilesystemIterator::SKIP_DOTS);
  $ri = new RecursiveIteratorIterator($di, RecursiveIteratorIterator::CHILD_FIRST);
  foreach ($ri as $file) {
    if (
      $file->getFilename() == "config.php"
      || $file->getFilename() == "header.php"
      || $file->getFilename() == "footer.php"
      || $file->getFilename() == "customStyles.css"
      || $file->getFilename() == ".htaccess"
    ) {
      // echo 'Copying' . $file->getRealPath() . " to " . $dest . $file->getFilename() . "\n";
      copy($file->getRealPath(), $dest . $file->getFilename());
    }
  }
}
function emptyDir($dir)
{
  $di = new RecursiveDirectoryIterator($dir, FilesystemIterator::SKIP_DOTS);
  $ri = new RecursiveIteratorIterator($di, RecursiveIteratorIterator::CHILD_FIRST);
  foreach ($ri as $file) {
    // $file->isDir() ?  rmdir($file) : unlink($file);
    if (strpos($file->getRealPath(), 'temp') == false && strpos($file->getRealPath(), '.zip') == false) {
      if ($file->isDir()) {
        // echo "Removing directory " . $file . "\n";
        rmdir($file->getRealPath());
      } else {
        // echo "Removing file " . $file->getRealPath() . "\n";
        unlink($file->getRealPath());
      }
    } else {
      // echo "Skipped " . $file->getRealPath . "\n";
    }
  }
}
?>
<?php if ($updating == false && $updateSucces == false) : ?>

  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- Add icon library -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
      body {
        font-family: Arial, Helvetica, sans-serif;
      }

      * {
        box-sizing: border-box;
      }

      .input-container {
        display: -ms-flexbox;
        /* IE10 */
        display: flex;
        width: 100%;
        margin-top: 8px;
        margin-bottom: 16px;
      }

      .icon {
        padding: 10px;
        background: dodgerblue;
        color: white;
        min-width: 50px;
        text-align: center;
      }

      .input-field {
        width: 100%;
        padding: 10px;
        outline: none;
      }

      .input-field:focus {
        border: 2px solid dodgerblue;
      }

      /* Set a style for the submit button */
      .btn {
        margin-top: 8px;
        background-color: dodgerblue;
        color: white;
        padding: 15px 20px;
        border: none;
        cursor: pointer;
        width: 100%;
        opacity: 0.9;
      }

      .btn:hover {
        opacity: 1;
      }

      .error {
        color: red;
        font-size: 14;
      }

      .headline {
        text-align: center;
        margin-top: 15%;
      }

      .description {
        font-size: small;
      }
    </style>
  </head>

  <body>
    <form method="post" action="" style="max-width:500px;margin:auto">
      <h2 class="headline">Update your installation</h2>
      <span class="error"> <?php echo $currentPwdErr; ?></span>
      <div class="input-container">
        <i class="fa fa-key icon"></i>
        <input class="input-field" type="password" placeholder="Your password" name="currentPwd" value="<?php echo $currentPwd; ?>">
      </div>
      <button type="submit" name="submit" class="btn">Update</button>
    </form>
  </body>
<?php endif; ?>
<?php if ($updateSucces == true) : ?>

  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- Add icon library -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
      body {
        font-family: Arial, Helvetica, sans-serif;
      }

      * {
        box-sizing: border-box;
      }

      .headline {
        text-align: center;
        margin-top: 10%;
      }

      .icon_success {
        font-size: 200px;
        color: #4BB543;
        position: relative;
        top: calc(50% - 10px);
      }
    </style>
  </head>

  <body>
    <div class="headline">
      <h2> Update successful ! </h2>
      <i class="fa fa-check-circle fa-10x icon_success"></i>
    </div>
  </body>
<?php endif; ?>